#include "creddy.h"

void verify_main(options_t *opts) {
    certificate_t *subject_cert = NULL;

    if (opts->cert == NULL)
        usage(opts);

    certificate_t *cert = cert_from_file(opts->cert);

    if (opts->attrcert != NULL)
        subject_cert = attr_cert_from_file(opts->attrcert);
    else
        subject_cert = cert;

    int good = 0;
    if (subject_cert->issued_by(subject_cert, cert))
        if (subject_cert->get_validity(subject_cert, NULL, NULL, NULL))
            if (cert->get_validity(cert, NULL, NULL, NULL)) {
                puts("signature good, certificates valid");
                good = 1;
            }
            else
                puts("signature good, issuer cert not valid now");
        else
            puts("certificate not valid now");
    else
        puts("signature invalid");

    if (subject_cert != cert)
        DESTROY_IF(subject_cert);
    DESTROY_IF(cert);

    exit(good);
}
